<?php
declare(strict_types=1);

namespace FiloBlu\ExtMailChimp\Plugin;

use Ebizmarts\MailChimp\Controller\WebHook\Index;
use FiloBlu\Core\Helper\Url;
use Magento\Framework\App\Config\ScopeConfigInterface;
use Magento\Store\Model\StoreManagerInterface;

class UseAdminUrl
{

    /**
     * @var Url
     */
    private $helper;
    /**
     * @var ScopeConfigInterface
     */
    private $scopeConfig;

    /**
     * @var StoreManagerInterface
     */
    private $storeManager;

    /**
     * @param Url $helper
     * @param ScopeConfigInterface $scopeConfig
     * @param StoreManagerInterface $storeManager
     */
    public function __construct(Url $helper, ScopeConfigInterface $scopeConfig, StoreManagerInterface $storeManager)
    {
        $this->helper = $helper;
        $this->scopeConfig = $scopeConfig;
        $this->storeManager = $storeManager;
    }

    public function aroundGetUrl($subject, $proceed, $routePath = null, $routeParams = null)
    {
        if ($routePath === Index::WEBHOOK__PATH && $this->scopeConfig->isSetFlag('mailchimp/general/use_admin_url')) {
            $routeParams['_scope'] = $this->storeManager->getDefaultStoreView()->getId();
            $url = $proceed($routePath, $routeParams);
            return $this->helper->replaceWithAdminDomain($url);
        }
        return $proceed($routePath, $routeParams);
    }
}
